IMPLEMENTATION MODULE Fonts;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
FROM FIO IMPORT File,Open,Exists,Size,RdBin,Close;
FROM Graph IMPORT Plot,Line;
FROM Str IMPORT Length;

CLASS IMPLEMENTATION Font;

PROCEDURE Min(x,y:SHORTCARD):SHORTCARD;
BEGIN
   IF x<y THEN RETURN(x) ELSE RETURN(y) END
END Min;

PROCEDURE Convert(VAR c:CHAR);
VAR o: SHORTCARD;
BEGIN
  CASE Convert_Num OF
  | 1:
    o:=SHORTCARD(ORD(c));
    CASE o OF
      | ORD('')..ORD(''): c:=CHR(o+64);
      | ORD('')..ORD(''): c:=CHR(o+16);
      | ORD('')+1..ORD('')-1: c:=CHR(o-48);
      | 240..255: c:=CHR(o-64);
    END;
  | 2:
    CASE c OF
       | '0'..'9': ;
       | '+': c:=CHR(58);
       | '-': c:=CHR(59);
       | '.': c:=CHR(60);
       | 'E': c:=CHR(61);
       | ' ': c:=CHR(62);
    ELSE c:=CHR(62);
    END;
  END;
END Convert;

PROCEDURE ReleaseFont;
BEGIN
     IF Dat<>NIL THEN
        DEALLOCATE(Dat,FontLen);
        Dat:=NIL;
     END;
END ReleaseFont;

PROCEDURE LoadFont(FontName:ARRAY OF CHAR; Conv:SHORTCARD):BOOLEAN;
VAR f:File; t: LONGCARD; t1: CARDINAL;
BEGIN
     ReleaseFont;
     IF ~Exists(FontName) THEN RETURN(FALSE) END;
     f:=Open(FontName);
     t:=Size(f);
     IF t>MAX(CARDINAL) THEN RETURN(FALSE) END;
     FontLen:=CARDINAL(t);
     IF ~Available(FontLen) THEN RETURN(FALSE) END;
     ALLOCATE(Dat,FontLen);
     t1:=RdBin(f,Dat^,FontLen);
     IF t1#FontLen THEN RETURN(FALSE) END;
     Close(f);
     FirstSymbol:=Dat^[95];
     LastSymbol:=Dat^[96];
     Height:=Dat^[88];
     Convert_Num:=Conv;
     RETURN(TRUE)
END LoadFont;

PROCEDURE CharWidth(c:CHAR):SHORTCARD;
BEGIN
     IF (SHORTCARD(ORD(c))<FirstSymbol)
        OR (SHORTCARD(ORD(c))>LastSymbol) THEN c:=' ' END;
     RETURN(Dat^[118+4*(ORD(c)-CARDINAL(FirstSymbol))])
END CharWidth;

PROCEDURE CharAddr(c:CHAR):CARDINAL;
BEGIN
     IF (SHORTCARD(ORD(c))<FirstSymbol)
        OR (SHORTCARD(ORD(c))>LastSymbol) THEN c:=' ' END;
     RETURN(CARDINAL(Dat^[120+4*(ORD(c)-CARDINAL(FirstSymbol))])+
                CARDINAL(Dat^[121+4*(ORD(c)-CARDINAL(FirstSymbol))])*256);
END CharAddr;

PROCEDURE OutCharXY(VAR x: INTEGER; y: INTEGER; col: CARDINAL; c:CHAR);
VAR ttm:INTEGER;
    Cha: CARDINAL;(*adr of char*)
    i,j,k,l,t,Wdth: SHORTCARD;
    AItalic: BOOLEAN;
BEGIN
     Convert(c);
     Cha:=CharAddr(c);
     Wdth:=CharWidth(c)-1;
     AItalic:=(TextAttr AND F_Italic)=F_Italic;
     IF (TextAttr AND F_Bold)=0 THEN
       FOR i:=0 TO (Wdth DIV 8) DO
         FOR j:=0 TO Min(7,Wdth-i*8) DO
             FOR k:=0 TO Height-1 DO
                 (*l:=$80 shr j;*)
                 l:=128 >> j;
                 t:=Dat^[Cha+CARDINAL(k+i*Height)];
                 IF (t AND l)=l THEN
                   IF AItalic THEN
                      Plot(x+INTEGER(i*8+j)+INTEGER((Height-1-k) DIV IShift),
                           y+INTEGER(k), col)
                   ELSE
                     Plot(x+INTEGER(i*8+j), y+INTEGER(k), col)
                   END
                 END
             END;
             (*l:=l DIV 2*)
          END
       END;
       (*MoveRel(Wdth+1,0);*)
       x:=x+INTEGER(Wdth+1);
     ELSE
       FOR i:=0 TO (Wdth DIV 8) DO
         FOR j:=0 TO Min(7,Wdth-i*8) DO
             FOR k:=0 TO Height-1 DO
                 (*l:=$80 shr j;*)
                 l:=128 >> j;
                 IF ((Dat^[Cha+CARDINAL(k+i*Height)]) AND l)=l THEN
                   IF AItalic THEN
                      ttm:=x+INTEGER(i*8+j)+INTEGER((Height-1-k) DIV IShift);
                      Line(ttm,y+INTEGER(k),ttm+1,y+INTEGER(k),col)
                   ELSE
                      Line(x+INTEGER(i*8+j),y+INTEGER(k),
                           x+INTEGER(i*8+j+1),y+INTEGER(k),col)
                   END
                 END
             END
          END
       END;
       (*MoveRel(Wdth+2,0);*)
       x:=x+INTEGER(Wdth+2);
    END
END OutCharXY;

PROCEDURE OutStringXY(x,y: INTEGER; col: CARDINAL; s: ARRAY OF CHAR);
VAR i:CARDINAL;
BEGIN
  IF Length(s)>0 THEN
     FOR i:=0 TO Length(s)-1 DO OutCharXY(x,y,col,s[i]) END
  END
END OutStringXY;

PROCEDURE StrWidth(s:ARRAY OF CHAR): CARDINAL;
VAR i,Sum: CARDINAL;
    c: CHAR;
BEGIN
  Sum:=0;
  IF Length(s)>0 THEN
     FOR i:=0 TO Length(s)-1 DO
         c:=s[i];
         Convert(c);
         Sum:=Sum+CARDINAL(CharWidth(c));
     END
  END;
  RETURN(Sum);
END StrWidth;

PROCEDURE OutStringC(x1,x2,y:INTEGER; col: CARDINAL; s:ARRAY OF CHAR);
          (*Center between x1 & x2*)
VAR l: CARDINAL;
BEGIN
     l:=StrWidth(s);
     OutStringXY(x1+((x2-x1-INTEGER(l)) DIV 2),y,col,s);
END OutStringC;

PROCEDURE FontHeight():SHORTCARD;
BEGIN
  RETURN(Height);
END FontHeight;

PROCEDURE SetTextAttr(Attr,ISh:SHORTCARD);
BEGIN
     TextAttr:=Attr;
     IF ISh=0 THEN IShift:=1 ELSE IShift:=ISh END
END SetTextAttr;

BEGIN
   Dat:=NIL;
   SetTextAttr(0,3);
END Font;

BEGIN
END Fonts.