IMPLEMENTATION MODULE GraWin;
FROM Str IMPORT IntToStr,RealToStr,FixRealToStr;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
FROM Graph IMPORT SetVideoMode,Rectangle,Line,Plot,GetImage,ImageSize,PutImage,
                  _GPSET,SetLinestyle;
FROM IO IMPORT WrStr,RdKey;
FROM BegData IMPORT TypeData,NullTD,Title;

CLASS IMPLEMENTATION Window;

  PROCEDURE Init;
  BEGIN
    x1:=0; x2:=0; y1:=0; y2:=0;
    xr1:=0.; xr2:=0.; yr1:=0.; yr2:=0.;
    hxg:=0.; hyg:=0.;
    cf:=15; cr:=8; cg:=7; ct:=3; ca:=3; cta:=11;
    IF ~font_d.LoadFont('service\cmpr3x6.fnt',2) THEN
       WrStr('  䠩 service\cmpr3x6.fnt'); HALT
    END;
    IF ~font_t.LoadFont('service\sserif10.fnt',1) THEN
       WrStr('  䠩 service\sserif10.fnt'); HALT
    END;
    xttl:=font_d.StrWidth(' -0.0000E+0');
    yttl:=CARDINAL(font_t.FontHeight()+2);
  END Init;

  PROCEDURE SetTitle(s: ARRAY OF CHAR; active: BOOLEAN);
   VAR c1,c2: CARDINAL;
  BEGIN
    IF active THEN c1:=ca; c2:=cta ELSE c1:=cf; c2:=ct END;
    Rectangle(x1+1-xttl,y1-1-yttl,x2-2,y1-5,c1,TRUE);
    font_t.OutStringC(x1-1-xttl,x2-1,y1-2-yttl,c2,s);
  END SetTitle;

  PROCEDURE Open(wx1,wx2,wy1,wy2: CARDINAL; s: ARRAY OF CHAR;
                 active: BOOLEAN);
   VAR c1,c2: CARDINAL;
  BEGIN
    x1:=wx1; x2:=wx2; y1:=wy1; y2:=wy2;
    Rectangle(x1-xttl,y1-2-yttl,x2-1,y2+yttl,cf,TRUE);
    Rectangle(x1-2-xttl,y1-4-yttl,x2+1,y2+2+yttl,cg,FALSE);
    Rectangle(x1-1-xttl,y1-3-yttl,x2,y2+1+yttl,cg,FALSE);
    Line(x1-3-xttl,y1-5-yttl,x1-3-xttl,y2+2+yttl,cf);
    Line(x1-2-xttl,y1-5-yttl,x2+1,y1-5-yttl,cf);
    Line(x2+2,y1-5-yttl,x2+2,y2+3+yttl,cr);
    Line(x1-2-xttl,y2+3+yttl,x2+2,y2+3+yttl,cr);
    Line(x1-xttl,y1-2-yttl,x1-xttl,y1-4,cr);
    Line(x1+1-xttl,y1-2-yttl,x2-2,y1-2-yttl,cr);
    Line(x1-xttl,y1-3,x2-1,y1-3,cg);
    Line(x1-xttl,y1-2,x2-1,y1-2,cg);
    Line(x1-1,y1-1,x1-1,y2-1,cr);
    Line(x1,y1-1,x2-1,y1-1,cr);
    Line(x1-2,y1-2,x1-2,y2,cg);
    Line(x1-2,y2,x2-1,y2,cg);
    SetTitle(s,active);
  END Open;

  PROCEDURE LineDraw(wx1,wx2,wy1,wy2: TypeData; c: CARDINAL);
    VAR xt1,xt2,yt1,yt2,m,type: CARDINAL;
  BEGIN
    type:=c DIV 16;
    CASE type OF
      | 0: m:=0FFFFH;
      | 1: m:=0F0F0H;
      | 2: m:=0AAAAH;
      ELSE m:=0F0F0H;
    END;
    SetLinestyle(m);
    RealToWin(wx1,wx2,wy1,wy2,xt1,xt2,yt1,yt2);
    IF (xt1#0) OR (xt2#0) OR (yt1#0) OR (yt2#0) THEN
      Line(xt1,yt1,xt2,yt2,c)
    END;
    SetLinestyle(0FFFFH);
  END LineDraw;

  PROCEDURE OutStrX(x: TypeData; c: CARDINAL);
    VAR xt,xs: CARDINAL;
        s: ARRAY [1..5] OF CHAR;
        ok: BOOLEAN;
  BEGIN
    IntToStr(LONGINT(x),s,10,ok);
    xs:=font_d.StrWidth(s);
    xt:=CARDINAL(TypeData(x1)+(TypeData(x2)-TypeData(x1))/(xr2-xr1)*(x-xr1))
        -(xs DIV 2);
    IF (xt>=x1-1-xttl) & (xt+xs<=x2) THEN
      font_d.OutStringXY(xt,y2+3,c,s)
    END
  END OutStrX;

  PROCEDURE OutStrY(y: TypeData; c: CARDINAL);
    VAR yt,xs,ys: CARDINAL;
        s: ARRAY [1..12] OF CHAR;
        ok: BOOLEAN;
  BEGIN
    IF ~(y=0.) AND ((ABS(y)>=1.0E+5) OR (ABS(y)<=9.999999E-4)) THEN
       RealToStr(LONGREAL(y),5,FALSE,s,ok);
    ELSE
       FixRealToStr(LONGREAL(y),3,s,ok);
    END;
    xs:=font_d.StrWidth(s);
    ys:=CARDINAL(font_d.FontHeight());
    yt:=CARDINAL(TypeData(y2)-(TypeData(y2)-TypeData(y1))/(yr2-yr1)*(y-yr1))
        -(ys DIV 2);
    IF (yt>=y1) & (yt<=y2) THEN
      font_d.OutStringXY(x1-4-xs,yt,c,s)
    END
  END OutStrY;

  PROCEDURE SetRealCoord(wxr1,wxr2,wyr1,wyr2: TypeData);
  BEGIN
    xr1:=wxr1; xr2:=wxr2; yr1:=wyr1; yr2:=wyr2;
  END SetRealCoord;

  PROCEDURE RealToWin(wxr1,wxr2,wyr1,wyr2: TypeData; VAR wx1,wx2,wy1,wy2: CARDINAL);
  VAR xt1,xt2,yt1,yt2,t: TypeData;
  BEGIN
    xt1:=wxr1; xt2:=wxr2; yt1:=wyr1; yt2:=wyr2;
    IF xt1>xt2 THEN t:=xt1; xt1:=xt2; xt2:=t; t:=yt1; yt1:=yt2; yt2:=t END;
    IF (xt1>=xr2) OR (xt2<=xr1) THEN
       wx1:=0; wx2:=0; wy1:=0; wy2:=0; RETURN
    END;
    IF xt1<xr1 THEN yt1:=yt1+(xr1-xt1)/(xt2-xt1)*(yt2-yt1); xt1:=xr1 END;
    IF xt2>xr2 THEN yt2:=yt2+(xr2-xt2)/(xt2-xt1)*(yt2-yt1); xt2:=xr2 END;
    IF yt1>yt2 THEN t:=xt1; xt1:=xt2; xt2:=t; t:=yt1; yt1:=yt2; yt2:=t END;
    IF (yt1>=yr2) OR (yt2<=yr1) THEN
       wx1:=0; wx2:=0; wy1:=0; wy2:=0; RETURN
    END;
    IF yt1<yr1 THEN xt1:=xt1+(yr1-yt1)/(yt2-yt1)*(xt2-xt1); yt1:=yr1 END;
    IF yt2>yr2 THEN xt2:=xt2+(yr2-yt2)/(yt2-yt1)*(xt2-xt1); yt2:=yr2 END;
    wx1:=INTEGER(TypeData(x1)+(TypeData(x2)-TypeData(x1))/(xr2-xr1)*(xt1-xr1));
    wx2:=INTEGER(TypeData(x1)+(TypeData(x2)-TypeData(x1))/(xr2-xr1)*(xt2-xr1));
    wy1:=INTEGER(TypeData(y2)-(TypeData(y2)-TypeData(y1))/(yr2-yr1)*(yt1-yr1));
    wy2:=INTEGER(TypeData(y2)-(TypeData(y2)-TypeData(y1))/(yr2-yr1)*(yt2-yr1));
  END RealToWin;

  PROCEDURE Grid(hx,hy: TypeData);
  VAR xt1,xt2,yt1,yt2: CARDINAL; x,y: TypeData; c: CARDINAL;
  BEGIN
    hxg:=TypeData(INTEGER(hx)); hyg:=hy;
    x:=TypeData(INTEGER(xr1));
    WHILE (x<=xr2) DO
      IF ABS(x)<=NullTD THEN x:=0.; c:=cr ELSE c:=cg+32 END;
      LineDraw(x,x,yr1,yr2,c);
      OutStrX(x,c);
      x:=x+hxg;
    END;
    IF (yr1<0.) & (yr2>0.) THEN
      LineDraw(xr1,xr2,0.,0.,cr);
      OutStrY(0.,cr);
      c:=cg+32;
      y:=hyg;
      WHILE (y<=yr2) DO
        LineDraw(xr1,xr2,y,y,c);
        OutStrY(y,c);
        y:=y+hyg;
      END;
      y:=-hyg;
      WHILE (y>=yr1) DO
        LineDraw(xr1,xr2,y,y,c);
        OutStrY(y,c);
        y:=y-hyg;
      END
    ELSE
      y:=yr1;
      WHILE (y<=yr2) DO
        LineDraw(xr1,xr2,y,y,c);
        OutStrY(y,c);
        y:=y+hyg;
      END
    END;
  END Grid;

  PROCEDURE Close;
  BEGIN
    Rectangle(x1-3-xttl,y1-5-yttl,x2+1,y2+3+yttl,0,TRUE);
    x1:=0; x2:=0; y1:=0; y2:=0;
    xr1:=0.; xr2:=0.; yr1:=0.; yr2:=0.;
  END Close;

BEGIN
  Init;
END Window;

CLASS IMPLEMENTATION WinDiag;

  PROCEDURE Init;
  BEGIN
    x1:=0; x2:=0; y1:=0; y2:=0;
    cf:=15; cr:=8; cg:=7;  ct:=3; ca:=3; cta:=11;
    IF ~font_c.LoadFont('service\sserif10.fnt',1) THEN
       WrStr('  䠩 service\sserif10.fnt'); HALT
    END;
    xttl:=font_c.StrWidth('-0000');
    yttl:=CARDINAL(font_c.FontHeight());
    Back:=NIL;
  END Init;

  PROCEDURE Open(wx1,wx2,wy1,wy2: CARDINAL; s: ARRAY OF CHAR; active: BOOLEAN);
    VAR c1,c2: CARDINAL;
  BEGIN
    x1:=wx1; x2:=wx2; y1:=wy1; y2:=wy2;
(*
    sBack:=CARDINAL(ImageSize(x1-1,y1-5-yttl,x2+1,y2+1));
    ALLOCATE(Back,sBack);
    GetImage(x1-1,y1-5-yttl,x2+1,y2+1,Back);
*)
    Rectangle(x1-1,y1-5-yttl,x2+1,y2+1,cr,TRUE);
    IF active THEN c1:=ca; c2:=cta ELSE c1:=cf; c2:=ct END;
    Rectangle(x1+1,y1-3-yttl,x2-1,y1-3,c1,TRUE);
    Rectangle(x1,y1,x2,y2,cf,TRUE);
    font_c.OutStringC(x1+1,x2-1,y1-2-yttl,c2,s);
  END Open;

  PROCEDURE SetTitle(s: ARRAY OF CHAR; active: BOOLEAN);
   VAR c1,c2: CARDINAL;
  BEGIN
    IF active THEN c1:=ca; c2:=cta ELSE c1:=cf; c2:=ct END;
    Rectangle(x1+1,y1-3-yttl,x2-1,y1-3,c1,TRUE);
    font_c.OutStringC(x1+1,x2-1,y1-2-yttl,c2,s);
  END SetTitle;


  PROCEDURE OutStr(x,y,c: CARDINAL; s: ARRAY OF CHAR);
  BEGIN
    font_c.OutStringXY(x+x1,y+y1,c,s);
  END OutStr;

  PROCEDURE Close;
  BEGIN
    IF Back#NIL THEN
      PutImage(x1-1,y1-5-yttl,Back,_GPSET);
      DEALLOCATE(Back,sBack)
    END;
    x1:=0; x2:=0; y1:=0; y2:=0;
  END Close;

BEGIN
  Init;
END WinDiag;

CLASS IMPLEMENTATION WinInfo;

  PROCEDURE Init;
  BEGIN
    ne:=0; np:=0; ns:=18;
    x1:=0; x2:=0; y1:=0; y2:=0; ys:=12;
    xdraw:=NIL;
    xcol:=NIL;
    tp:=NIL;
  END Init;

  PROCEDURE Define(wx1,wx2,wy1,wy2: CARDINAL; bd: BDEth; VAR ok: BOOLEAN);
    VAR i,j,k,c: SHORTCARD;
        s: CARDINAL;
  BEGIN
    Dispose;
    ok:=TRUE;
    ne:=bd.nEth; np:=bd.nVP; nf:=bd.nFn; ns:=np+nf;
    s:=CARDINAL(ne*(np+nf))*SIZE(BOOLEAN);
    IF Available(s) THEN ALLOCATE(xdraw,s) ELSE ok:=FALSE END;
    s:=CARDINAL(ne*(np+nf))*SIZE(CARDINAL);
    IF Available(s) THEN ALLOCATE(xcol,s) ELSE ok:=FALSE END;
    s:=CARDINAL(np+nf)*SIZE(Title);
    IF Available(s) THEN ALLOCATE(tp,s) ELSE ok:=FALSE END;
    IF ok THEN
      FOR j:=1 TO ne DO
        FOR i:=1 TO np DO
          k:=(i-1)*ne+j;
          xdraw^[k]:=TRUE;
          xcol^[k]:=CARDINAL((j-1)*64+((i-1) DIV 14)*16+((i-1) MOD 14)+1);
        END;
        FOR i:=1 TO nf DO
          k:=(np+i-1)*ne+j;
          xdraw^[k]:=TRUE;
          c:=i+np-1;
          xcol^[k]:=CARDINAL((j-1)*64+(c DIV 14)*16+(c MOD 14)+1);
        END;
      END;
      FOR i:=1 TO np DO
        tp^[i]:=bd.tVP^[i];
      END;
      FOR i:=1 TO nf DO
        tp^[np+i]:=bd.tFn^[i];
      END;
      x1:=wx1; y1:=wy1; x2:=wx2; y2:=wy2;
      xk:=4;
    END;
    pm:=1;
  END Define;

  PROCEDURE Open(s: ARRAY OF CHAR);
    VAR i,j,k: SHORTCARD;
  BEGIN
    w.Open(x1,x2,y1,y2,s,FALSE);
    FOR i:=1 TO np+nf DO
      Rectangle(x1+10,y1+11+ys*CARDINAL(i-1),
                x1+11+CARDINAL(ne)*xk,y1+19+ys*CARDINAL(i-1),8,FALSE);
      FOR j:=1 TO ne DO
        k:=(i-1)*ne+j;
        IF xdraw^[k] THEN
          Rectangle(x1+11+CARDINAL(j-1)*xk,y1+12+ys*CARDINAL(i-1),
                    x1+10+CARDINAL(j)*xk,  y1+18+ys*CARDINAL(i-1),
                    xcol^[k],TRUE);
        END;
      END;
      w.OutStr(15+CARDINAL(ne)*xk,7+ys*CARDINAL(i-1),3,tp^[i]);
    END;
  END Open;

  PROCEDURE SetTitle(s: ARRAY OF CHAR; active: BOOLEAN);
  BEGIN
    w.SetTitle(s,active);
  END SetTitle;

  PROCEDURE Edit(VAR c: CHAR);
    VAR nc,k,i,j: SHORTCARD;
  BEGIN
    REPEAT
      Rectangle(x1+8,y1+9+ys*CARDINAL(pm-1),
                x1+13+CARDINAL(ne)*xk,y1+21+ys*CARDINAL(pm-1),8,FALSE);
      c:=RdKey();
      CASE c OF
      | CHR(0) :
        Rectangle(x1+8,y1+9+ys*CARDINAL(pm-1),
                  x1+13+CARDINAL(ne)*xk,y1+21+ys*CARDINAL(pm-1),15,FALSE);
        c:=RdKey();
        CASE c OF
        | CHR(72): IF pm=1 THEN pm:=ns ELSE DEC(pm) END;
        | CHR(80): pm:=(pm MOD ns)+1;
        END;
        Rectangle(x1+8,y1+9+ys*CARDINAL(pm-1),
                  x1+13+CARDINAL(ne)*xk,y1+21+ys*CARDINAL(pm-1),8,FALSE);
      | '1'..'9':
        nc:=SHORTCARD(ORD(c)-48);
        IF nc<=ne THEN
          k:=(pm-1)*ne+nc;
          xdraw^[k]:=~xdraw^[k];
          IF xdraw^[k] THEN
            Rectangle(x1+11+CARDINAL(nc-1)*xk,y1+12+ys*CARDINAL(pm-1),
                      x1+10+CARDINAL(nc)*xk,  y1+18+ys*CARDINAL(pm-1),
                      xcol^[k],TRUE);
          ELSE
            Rectangle(x1+11+CARDINAL(nc-1)*xk,y1+12+ys*CARDINAL(pm-1),
                      x1+10+CARDINAL(nc)*xk,  y1+18+ys*CARDINAL(pm-1),
                      15,TRUE);
          END;
        END;
      | '-':
        FOR i:=1 TO ne DO
          k:=(pm-1)*ne+i;
          xdraw^[k]:=FALSE;
        END;
        Rectangle(x1+11,y1+12+ys*CARDINAL(pm-1),
                  x1+10+CARDINAL(ne)*xk,  y1+18+ys*CARDINAL(pm-1),
                  15,TRUE);
      | '=':
        FOR i:=1 TO ne DO
          k:=(pm-1)*ne+i;
          xdraw^[k]:=TRUE;
          Rectangle(x1+11+CARDINAL(i-1)*xk,y1+12+ys*CARDINAL(pm-1),
                    x1+10+CARDINAL(i)*xk,  y1+18+ys*CARDINAL(pm-1),
                    xcol^[k],TRUE);
        END;
      | '_':
        FOR j:=1 TO np+nf DO
          FOR i:=1 TO ne DO
            k:=(j-1)*ne+i;
            xdraw^[k]:=FALSE;
          END;
          Rectangle(x1+11,y1+12+ys*CARDINAL(j-1),
                    x1+10+CARDINAL(ne)*xk,  y1+18+ys*CARDINAL(j-1),
                    15,TRUE);
        END;
      | '+':
        FOR j:=1 TO np+nf DO
          FOR i:=1 TO ne DO
            k:=(j-1)*ne+i;
            xdraw^[k]:=TRUE;
            Rectangle(x1+11+CARDINAL(i-1)*xk,y1+12+ys*CARDINAL(j-1),
                      x1+10+CARDINAL(i)*xk,  y1+18+ys*CARDINAL(j-1),
                      xcol^[k],TRUE);
          END;
        END;
      END;
    UNTIL((c=CHR(9)) OR (c=CHR(27)) OR (c=CHR(13)) OR (c=' '));
    Rectangle(x1+8,y1+9+ys*CARDINAL(pm-1),
              x1+13+CARDINAL(ne)*xk,y1+21+ys*CARDINAL(pm-1),15,FALSE);
  END Edit;

  PROCEDURE Dispose;
  BEGIN
    ne:=0; np:=0;
    IF xdraw#NIL THEN DEALLOCATE(xdraw,CARDINAL(ne*np)*SIZE(BOOLEAN)) END;
    IF xcol#NIL THEN DEALLOCATE(xcol,CARDINAL(ne*np)*SIZE(CARDINAL)) END;
    IF tp#NIL THEN DEALLOCATE(tp,CARDINAL(np)*SIZE(Title)) END;
    x1:=0; y1:=0; x2:=0; y2:=0;
    xk:=0;
  END Dispose;

BEGIN
  Init;
END WinInfo;

  PROCEDURE GrMode;
  BEGIN
    IF ~SetVideoMode(18) THEN HALT END;
  END GrMode;

  PROCEDURE TxMode;
  BEGIN
    IF ~SetVideoMode(3) THEN HALT END;
  END TxMode;

BEGIN
END GraWin.
