IMPLEMENTATION MODULE ServFile;
FROM IO       IMPORT WrStr,RdKey,RdStr;
FROM FIO      IMPORT SetDrive,GetDrive,GetDir,ChDir,ReadFirstEntry,FileAttr,
                     directory,readonly,archive,IOcheck,
                     ReadNextEntry,DirEntry,PathTail;
FROM Storage  IMPORT ALLOCATE,DEALLOCATE;
FROM Str      IMPORT Insert,Lows,Append,Length,CharPos,Delete,Match,Caps;
FROM Lib      IMPORT QSort;
FROM CorrDat  IMPORT CT,CF,CA,CM,CR;
              IMPORT Window;

CONST nDir = 500; nWin = 19; nhWin = 10;
TYPE DirRec = RECORD
                attr: FileAttr;
                Name: PathTail;
              END;
     aDirRec = ARRAY [1..nDir] OF DirRec;
     paDirRec = POINTER TO aDirRec;
VAR WD: Window.WinDef; WT,WT1: Window.WinType;
    pad: paDirRec;

PROCEDURE FnLess(k,n: CARDINAL): BOOLEAN;
  VAR a,b: PathTail; i: CARDINAL;
BEGIN
  a:=pad^[k].Name; b:=pad^[n].Name;
  i:=0; WHILE ((i<12) & (a[i]=b[i])) DO INC(i) END;
  IF (i<12) & (a[i]<b[i]) THEN RETURN(TRUE) ELSE RETURN(FALSE) END;
END FnLess;

PROCEDURE FnSwap(k,n: CARDINAL);
  VAR p: PathTail; a: FileAttr;
BEGIN
  p:=pad^[k].Name; pad^[k].Name:=pad^[n].Name; pad^[n].Name:=p;
  a:=pad^[k].attr; pad^[k].attr:=pad^[n].attr; pad^[n].attr:=a;
END FnSwap;

PROCEDURE RdName(VAR f: FName; VAR ok: SHORTCARD);
  VAR i: CARDINAL; c: CHAR;
      Drive,Drive1: SHORTCARD;
      Dir,Dir1: ARRAY [0..255] OF CHAR;
      Ok: BOOLEAN;
      DirEnt: DirEntry;
      pMenu: SHORTCARD[1..4];
      sf: PathTail;
      fl,fk,fs: CARDINAL;


PROCEDURE sFile(s,k: CARDINAL; m: BOOLEAN);
BEGIN
  IF m THEN
     Window.TextBackground(CA);
     f:=FName(pad^[s+k].Name);
     Window.GotoXY(13,1); sf:=PathTail('            ');
     Insert(sf,f,0); WrStr(sf);
     Window.TextBackground(CM);
  ELSE Window.TextBackground(CA) END;
  Window.GotoXY(2+13*(k DIV 10),(k MOD 10)+3);
  IF s+k>fl THEN WrStr('            ');
  ELSIF pad^[s+k].Name[0]='.' THEN
    WrStr('..          ');
  ELSE
    WrStr(pad^[s+k].Name);
  END;
END sFile;

PROCEDURE sFileWin;
BEGIN
  FOR i:=0 TO nWin DO sFile(fs,i,FALSE) END;
END sFileWin;

PROCEDURE ReadDir;
 VAR a,c: PathTail; i,j,s,t: CARDINAL;
BEGIN
  Ok:=ReadFirstEntry('*.*',FileAttr{readonly,directory,archive},DirEnt);
  i:=1;
  Ok:=ReadNextEntry(DirEnt);
  WHILE Ok & (i<=nDir) DO
    IF ~(directory IN DirEnt.attr) THEN Lows(DirEnt.Name) END;

    c:=DirEnt.Name;
    IF c[0]='.' THEN a:=c
    ELSE
      t:=0; s:=0;
      REPEAT
        IF c[t]#'.' THEN
          IF c[t]#CHR(0) THEN a[t+s]:=c[t]
          ELSE FOR j:=t TO 7 DO a[j]:=' ' END;
               FOR j:=t TO 11 DO a[j]:=' ' END; s:=12-t
          END
        ELSE FOR j:=t TO 7 DO a[j]:=' ' END; a[8]:='.'; s:=8-t
        END;
        INC(t);
      UNTIL(s+t>=12);
      IF ~(directory IN DirEnt.attr) THEN a[8]:='.' END;
      a[12]:=CHR(0)
    END;

    pad^[i].attr:=DirEnt.attr;
    pad^[i].Name:=a;
    INC(i);
    Ok:=ReadNextEntry(DirEnt);
  END;
  fl:=i-1; fk:=0; fs:=1;
  QSort(fl,FnLess,FnSwap);
  sFileWin;
END ReadDir;

PROCEDURE sMenu(n: SHORTCARD; m: BOOLEAN);
BEGIN
  IF m THEN Window.TextBackground(CM) ELSE Window.TextBackground(CA) END;
  CASE n OF
   | 1: Window.GotoXY(13,1); sf:=PathTail('            ');
        Insert(sf,f,0); WrStr(sf);
   | 2: sFile(fs,fk,m);
   | 3: Window.GotoXY(7,14); WrStr(' Ok ');
   | 4: Window.GotoXY(17,14); WrStr(' ⪠ ');
  END;
END sMenu;

BEGIN
  WT:=Window.Top();
  Window.PutOnTop(WT1);
  Window.CursorOff;
  Window.TextBackground(CA);
  ALLOCATE(pad, SIZE(aDirRec));
  IOcheck:=FALSE;
  Drive:=GetDrive(); GetDir(Drive,Dir);
  ChDir('MEP');
  ReadDir;

  ok:=255;
  pMenu:=2;
  sMenu(pMenu,TRUE);
  REPEAT
    c:=RdKey();
    CASE c OF
    | CHR(0):
      c:=RdKey();
      IF c=CHR(15) THEN
         sMenu(pMenu,FALSE);
         IF pMenu>1 THEN DEC(pMenu) ELSE pMenu:=4 END;
         sMenu(pMenu,TRUE);
      ELSIF pMenu=2 THEN
        CASE c OF
         | CHR(80):
           sFile(fs,fk,FALSE);
           IF fs+fk<fl THEN
             IF fk<nWin THEN INC(fk) ELSE INC(fs); sFileWin END
           END;
           sFile(fs,fk,TRUE)
         | CHR(72):
           sFile(fs,fk,FALSE);
           IF fs+fk>1 THEN
             IF fk>0 THEN DEC(fk) ELSE DEC(fs); sFileWin END
           END;
           sFile(fs,fk,TRUE)
         | CHR(77):
           sFile(fs,fk,FALSE);
           IF fs+fk+nhWin<fl THEN
             IF fk<nhWin THEN INC(fk,nhWin) ELSE INC(fs,nhWin); sFileWin END
           ELSIF fs+nWin<fl THEN
             fs:=fl-nWin; fk:=nWin; sFileWin;
           ELSE fk:=fl-fs
           END;
           sFile(fs,fk,TRUE)
         | CHR(75):
           sFile(fs,fk,FALSE);
           IF fk>=nhWin THEN DEC(fk,nhWin)
             ELSIF fs>nhWin THEN DEC(fs,nhWin); sFileWin
             ELSE fs:=1; fk:=0; sFileWin;
           END;
           sFile(fs,fk,TRUE)
        END;
      END
    | CHR(9):
      sMenu(pMenu,FALSE);
      IF pMenu<4 THEN INC(pMenu) ELSE pMenu:=1 END;
      sMenu(pMenu,TRUE);
    | CHR(13):
      CASE pMenu OF
        | 1: Window.TextBackground(CM);
             Window.GotoXY(13,1);  WrStr('            ');
             Window.GotoXY(13,1);
             RdStr(f);
             IF Match(f,'?:*') THEN
                Caps(f);
                Drive1:=SHORTCARD(f[1])-64;
                Drive1:=SetDrive(Drive1);
                ReadDir;
             ELSE
                ok:=0; c:=CHR(27);
             END;
        | 2: IF directory IN pad^[fs+fk].attr THEN
               ChDir(pad^[fs+fk].Name);
               ReadDir;
               sFile(fs,fk,TRUE)
             ELSE
               Drive1:=GetDrive(); GetDir(Drive1,Dir1);
               f:='';
               Append(f,CHR(Drive1+64));
               Append(f,':');
               Append(f,Dir1);
               IF Length(Dir1)>1 THEN Append(f,'\') END;
               Append(f,pad^[fs+fk].Name);
               ok:=0; c:=CHR(27);
             END;
        | 3: ok:=0; c:=CHR(27);
        | 4: c:=CHR(27);
      END;
    END
  UNTIL(c=CHR(27));
  sMenu(pMenu,FALSE);
  DEALLOCATE(pad, SIZE(aDirRec));
  Drive:=SetDrive(Drive); ChDir(Dir);
  Window.Hide(WT1);
  Window.PutOnTop(WT);
END RdName;

VAR i: CARDINAL;
BEGIN
  Window.CursorOff;
  WD:=Window.WinDef(21,2,49,17,CT,CF,TRUE,FALSE,TRUE,TRUE,
                    Window.SingleFrame,CR,CF);
  WT1:=Window.Open(WD);
  Window.SetTitle(WT1,' 롥 䠩 ',Window.CenterUpperTitle);
  Window.TextBackground(CF);
  Window.GotoXY(2,1);   WrStr(' 䠩:');
  Window.TextBackground(CA);
  Window.GotoXY(7,14);  WrStr(' Ok ');
  Window.GotoXY(17,14); WrStr(' ⪠ ');
  Window.GotoXY(13,1);  WrStr('            ');
  FOR i:=0 TO 9 DO
    Window.GotoXY(2,i+3); WrStr('                         ');
  END;

END ServFile.