IMPLEMENTATION MODULE SolveDat;
FROM IO       IMPORT KeyPressed,RdKey,WrStr;
FROM Graph    IMPORT Rectangle,Disc;
FROM Lib      IMPORT GetTime,RANDOM;
FROM Str      IMPORT IntToStr,Append,Concat;
FROM Storage  IMPORT ALLOCATE,DEALLOCATE,Available;
FROM BegData  IMPORT BDEth,TypeData,LongType,NullTD,UnlimTD,Title,PVect;
FROM EndData  IMPORT EDEth;
FROM MethodAR IMPORT ErrAdm,No;
FROM GraWin   IMPORT Window,GrMode,TxMode;
FROM Urs      IMPORT ConvertData,Function,OpenFunc;

  PROCEDURE TD(a: LongType):TypeData;
  BEGIN
    IF ABS(a)<=NulReal THEN RETURN(0.) ELSE RETURN(TypeData(a)) END;
  END TD;

  CLASS IMPLEMENTATION Solving;

    PROCEDURE Init;
      VAR i: SHORTCARD;
    BEGIN
      col:=5;
      nEth:=0; nVP:=0; nFn:=0;
      WY1:=TypeData(0.0); WY2:=TypeData(100.0); WYH:=TypeData(10.0);
      WX1:=0.; WX2:=0.; WXH:=0.; WXG:=0.125;
      X1:=55; Y1:=45; X2:=360; Y2:=440;
      XW1:=80; YW1:=80; XW2:=280; YW2:=110;
      XI1:=380; YI1:=45; XI2:=620; YI2:=460;
      XH1:=400; YH1:=45; XH2:=620; YH2:=190;
      x:=NIL; x1:=NIL; of:=NIL;
      adm_el:=TRUE;
      IF ~font_ss.LoadFont('service\sserif10.fnt',1) THEN
         WrStr('  䠩 service\sserif10.fnt'); HALT
      END;
    END Init;

    PROCEDURE Define(VAR bdat: BDEth; VAR ok: SHORTCARD);
    VAR i,j,e: SHORTCARD;
        s,s1: CARDINAL;
    BEGIN
      Dispose;
      bd:=bdat;
      nEth:=bd.nEth; nVP:=bd.nVP; nFn:=bd.nFn;
      T0:=bd.T0; T1:=bd.T1; th:=bd.Th;
      WX1:=T0; WX2:=T1; WXH:=StepX(WX1,WX2);
      s:=SIZE(TypeData)*CARDINAL(bd.nEth*(bd.nVP+bd.nFn));
      IF Available(s) THEN ALLOCATE(x,s) ELSE ok:=3; RETURN END;
      IF Available(s) THEN ALLOCATE(x1,s) ELSE ok:=3; RETURN END;
      FOR j:=1 TO bd.nVP+bd.nFn DO
        FOR i:=1 TO bd.nEth DO
          x^[(i-1)*bd.nVP+j]:=0.;
          x1^[(i-1)*bd.nVP+j]:=0.;
        END;
      END;
      ConvertData(bd);
      IF adm_el THEN
        ar.Alloc(bd.nEth,bd.nVP,ok);
        IF ok#0 THEN RETURN END;
        FOR i:=1 TO bd.nVP DO
          ar.InitFunc(i,Function(bd.TypeSystem,i));
        END;
        FOR e:=1 TO bd.nEth DO
          FOR i:=1 TO bd.nVP DO
            ar.InitX(e,i,LongType(bd.VP(i,e)));
            ar.InitdXh(e,i,0.);
          END;
        END;
        ar.Key:=No;
        ar.FUvl:=0;
        ar.ha:=LongType(th*0.25);
      ELSE
        el.Alloc(bd.nEth,bd.nVP,ok);
        FOR i:=1 TO bd.nVP DO
          el.InitFunc(i,Function(bd.TypeSystem,i));
        END;
        FOR e:=1 TO bd.nEth DO
          FOR i:=1 TO bd.nVP DO
            el.InitXE(e,i,LongType(bd.VP(i,e)));
            el.InitdXE(e,i,0.);
          END;
        END
      END;
      s1:=CARDINAL(bd.nFn)*SIZE(Func);
      IF Available(s1) THEN ALLOCATE(of, s1) ELSE ok:=3; RETURN END;
      FOR i:=1 TO bd.nFn DO
        of^[i]:=OpenFunc(bd.TypeSystem,i);
      END;
      ed.Alloc(bd,T0,T1,th,ok);
      IF ok#0 THEN RETURN END;
      ok:=0;
    END Define;

  PROCEDURE DrawGraph;
  VAR t,pn: TypeData; i,j,k: SHORTCARD;
      pnm: ARRAY SHORTCARD[1..10] OF TypeData;
      pre: TypeData;
      c: CARDINAL; prev: PVect;
  BEGIN
    c:=CARDINAL(ed.tData)*CARDINAL(ed.nVP+ed.nFn)*CARDINAL(ed.nEth);
    IF Available(c) THEN ALLOCATE(prev, c) END;
    FOR j:=1 TO ed.nEth DO pnm[j]:=0. END;
    t:=T0;
    FOR i:=1 TO ed.nVP+ed.nFn DO
      FOR j:=1 TO ed.nEth DO
          prev^[(i-1)*ed.nEth+j]:=ed.VP(i,j,TypeData(T0))
      END
    END;
    WHILE (t<=TP-th) AND (~KeyPressed()) DO
      FOR j:=1 TO ed.nEth DO
        FOR i:=1 TO ed.nVP DO
          k:=(i-1)*ed.nEth+j;
          IF wi.xdraw^[k] THEN
            pre:=ed.VP(i,j,TypeData(t+th));
            w.LineDraw(t,t+th,prev^[k],pre,wi.xcol^[k]);
            prev^[k]:=pre
          END
        END;
        FOR i:=1 TO ed.nFn DO
          k:=(ed.nVP+i-1)*ed.nEth+j;
          IF wi.xdraw^[k] THEN
            pre:=ed.Fn(i,j,TypeData(t+th));
            w.LineDraw(t,t+th,prev^[k],pre,wi.xcol^[k]);
            prev^[k]:=pre
          END
        END;
      END;

(*
      IF (bd.TypeSystem=1) OR (bd.TypeSystem=5) OR (bd.TypeSystem=6) THEN
        FOR j:=1 TO ed.nEth DO
          pn :=PasNap(j,t,ed);
          w.LineDraw(t,t+th,pnm[j],pn,12+CARDINAL(j-1)*16);
          pnm[j]:=pn;
        END;
      END;
*)
      t:=t+th
    END;
    DEALLOCATE(prev, c);
  END DrawGraph;

  PROCEDURE WGraph(s: ARRAY OF CHAR; graph,act: BOOLEAN);
  BEGIN
    w.Open(X1,X2,Y1,Y2,s,act);
    w.SetRealCoord(WX1,WX2,WY1,WY2);
    w.Grid(WXH,WYH);
    IF graph THEN DrawGraph END;
  END WGraph;

  PROCEDURE WHelp(s: ARRAY OF CHAR);
    VAR i: SHORTCARD;
  BEGIN
    wh.Open(XH1,XH2,YH1,YH2,s,FALSE);
    wh.OutStr(50, 5,3,' 䨪');
    wh.OutStr(10,18,3,'<Left>,<Right>-  ');
    wh.OutStr(10,31,3,'<Up>,<Down>-  न');
    wh.OutStr(40,44,3,' ⠡');
    wh.OutStr(10,57,3,'<Ins>,<Del>-  ');
    wh.OutStr(10,70,3,'<PgUp>,<PgDn>-  न');
    wh.OutStr(10,88,3,'<Space>-䨪   ');
    wh.OutStr(10,106,3,'<Tab>- 祭');
    wh.OutStr(10,119,3,'<Esc>-室   ');
  END WHelp;

  PROCEDURE SkyGraph;
    VAR i,j,xp,yp,rp: CARDINAL;
  BEGIN
    Rectangle(0,0,639,479,3,TRUE);
    FOR i:=1 TO 50 DO
      xp:=0; yp:=0; rp:=0;
      FOR j:=1 TO 3 DO
        xp:=xp+RANDOM(640); yp:=yp+RANDOM(480); rp:=rp+RANDOM(12);
      END;
      xp:=xp DIV 3; yp:=yp DIV 3;
      Disc(xp,yp,rp,11);
    END;
    Rectangle(0,0,639,18,1,TRUE);
    font_ss.SetTextAttr(1,3);
    font_ss.OutStringC(0,639,2,15,'஢ 樮 ᮢ');
    font_ss.SetTextAttr(0,3);
  END SkyGraph;

  PROCEDURE BotStr(s: ARRAY OF CHAR);
  BEGIN
    Rectangle(0,463,639,479,1,TRUE);
    font_ss.OutStringC(0,639,464,15,s);
  END BotStr;

  PROCEDURE Solve(VAR ok: SHORTCARD);
    VAR t,pn,ted: TypeData; i,j,k,m: SHORTCARD; c: CHAR;
        pnm: ARRAY SHORTCARD[1..10] OF TypeData;
        ok1,okey: BOOLEAN;
        tpr,tpr1: CARDINAL;
        timeH,timeM,timeS,timeMS: CARDINAL;
        time: LONGCARD;
        times: ARRAY [1..20] OF CHAR;
        s,s1: ARRAY [1..70] OF CHAR;
  BEGIN
    GrMode;
    SkyGraph;
    s:=' 樨 ...';
    WGraph(s,FALSE,TRUE);
    wi.Define(XI1,XI2,YI1,YI2,bd,okey);
    wi.Open('ଠ  祭');
    BotStr('   ࢠ 襩 <Esc>.');
    GetTime(timeH,timeM,timeS,timeMS);
    time:=(LONGCARD(timeH*60+timeM)*60+LONGCARD(timeS))*100+LONGCARD(timeMS);
    FOR j:=1 TO ed.nEth DO pnm[j]:=0. END;
    t:=T0;
    c:=CHR(0);
    tpr:=0;
    WHILE (t<=T1) AND (c#CHR(27)) DO
      IF KeyPressed() THEN c:=RdKey() END;
      IF adm_el THEN
        FOR j:=1 TO ed.nEth DO
          FOR i:=1 TO ed.nVP DO
            ted:=TD(ar.valX(j,i));
            ed.VPp (i,j,t,ted);
            ed.dVPp(i,j,t,TD(ar.valdXh(j,i)));
            m:=(i-1)*ed.nEth+j;
            x1^[m]:=x^[m];
            x^[m]:=ted;
          END;
          FOR i:=1 TO ed.nFn DO
            ted:=TD(of^[i](j,LongType(t),ar.X,ar.dXh));
            ed.Fnp (i,j,t,ted);
            m:=(ed.nVP+i-1)*ed.nEth+j;
            x1^[m]:=x^[m];
            x^[m]:=ted;
          END
        END;
      ELSE
        FOR j:=1 TO ed.nEth DO
          FOR i:=1 TO ed.nVP DO
            ted:=TD(el.valXE(j,i));
            ed.VPp (i,j,t,ted);
            ed.dVPp(i,j,t,TD(el.valdXE(j,i)));
            m:=(i-1)*ed.nEth+j;
            x1^[m]:=x^[m];
            x^[m]:=ted;
          END;
          FOR i:=1 TO ed.nFn DO
            ted:=TD(of^[i](j,LongType(t),el.XE,el.dXE));
            ed.Fnp (i,j,t,ted);
            m:=(ed.nVP+i-1)*ed.nEth+j;
            x1^[m]:=x^[m];
            x^[m]:=ted;
          END
        END;
      END;
      IF adm_el THEN
        ar.Adams(LongType(t),LongType(t+th),okA);
      ELSE
        el.Eyler(LongType(t),LongType(t+th),okA);
      END;

      IF okA#Ok THEN t:=T1 END; (********************)

      IF t>T0 THEN
        FOR j:=1 TO ed.nEth DO
          FOR i:=1 TO ed.nVP DO
            k:=(i-1)*ed.nEth+j;
            IF wi.xdraw^[k] THEN
              w.LineDraw(t,t+th,x1^[k],x^[k],wi.xcol^[k]);
            END
          END;
          FOR i:=1 TO ed.nFn DO
            k:=(ed.nVP+i-1)*ed.nEth+j;
            IF wi.xdraw^[k] THEN
              w.LineDraw(t,t+th,x1^[k],x^[k],wi.xcol^[k]);
            END
          END;
        END;
(*
        IF (bd.TypeSystem=1) OR (bd.TypeSystem=5) OR (bd.TypeSystem=6) THEN
          FOR j:=1 TO ed.nEth DO
            pn :=PasNap(j,t,ed);
            w.LineDraw(t,t+th,pnm[j],pn,12+CARDINAL(j-1)*16);
            pnm[j]:=pn;
          END;
        END;
*)
      END;

      t:=t+th;

      tpr1:=INTEGER((t-T0)/(T1-T0)*100.);
      IF tpr1>tpr THEN
         tpr:=tpr1; IntToStr(LONGINT(tpr),times,10,ok1);
         Concat(s1,s,times); Append(s1,'%'); w.SetTitle(s1,TRUE)
      END;
    END;
    TP:=t-th;
    GetTime(timeH,timeM,timeS,timeMS);
    time:=(LONGCARD(timeH*60+timeM)*60+LONGCARD(timeS))*100+LONGCARD(timeMS)-time;
    timeMS:=CARDINAL(time MOD 100); time :=time DIV 100;
    timeS :=CARDINAL(time MOD 60);  time :=time DIV 60;
    timeM :=CARDINAL(time MOD 60);
    timeH :=CARDINAL(time DIV 60);
    times:='';
    IntToStr(LONGINT(timeH),s1,10,ok1); Append(times,s1); Append(times,'  ');
    IntToStr(LONGINT(timeM),s1,10,ok1); Append(times,s1); Append(times,'  ');
    IntToStr(LONGINT(timeS),s1,10,ok1); Append(times,s1); Append(times,'.');
    IntToStr(LONGINT(timeMS),s1,10,ok1); Append(times,s1); Append(times,' ᥪ.');
    IF okA=Overflow THEN s1:='९  '
    ELSIF okA=Loop THEN s1:='横  '
    ELSIF TP=T1 THEN s1:='  襭 १ '
                ELSE s1:='  ࢠ १ ' END;
    Append(s1,times);
    w.SetTitle(s1,TRUE);
    ed.SaveArr(0);
    IF KeyPressed() THEN c:=RdKey() END;
    BotStr(' ᬮ १⮢   .');
    c:=RdKey();
    w.Close;
  END Solve;

  PROCEDURE StepX(xl,xr: TypeData): TypeData;
   VAR s,p: TypeData; sc: CARDINAL;
  BEGIN
    s:=ABS(xl-xr)/7.; p:=1.;
    WHILE(s<1.) OR (s>10.) DO
      IF s>10. THEN s:=s/10.; p:=p*10. ELSE s:=s*10.; p:=p/10. END
    END;
    sc:=CARDINAL(s);
    RETURN(TypeData(sc)*p);
  END StepX;

  PROCEDURE StepY(yd,yu: TypeData): TypeData;
   VAR s,p: TypeData; sc: CARDINAL;
  BEGIN
    s:=ABS(yd-yu)/10.; p:=1.;
    WHILE(s<1.) OR (s>10.) DO
      IF s>10. THEN s:=s/10.; p:=p*10. ELSE s:=s*10.; p:=p/10. END
    END;
    sc:=CARDINAL(s);
    RETURN(TypeData(sc)*p);
  END StepY;

  PROCEDURE AllGraph;
  VAR t,p: TypeData; i,j: SHORTCARD; z: CARDINAL;
  BEGIN
    WY2:=0.;
    WY1:=WY2;
    t:=T0;
    REPEAT
      t:=t+th;
      FOR j:=1 TO ed.nEth DO
        FOR i:=1 TO ed.nVP DO
          IF wi.xdraw^[(i-1)*ed.nEth+j] THEN
            p:=ed.VP(i,j,TypeData(t));
            IF p<WY1 THEN WY1:=p-(WY2-p)/10. END;
            IF p>WY2 THEN WY2:=p+(p-WY1)/10. END;
          END
        END;
        FOR i:=1 TO ed.nFn DO
          IF wi.xdraw^[(ed.nVP+i-1)*ed.nEth+j] THEN
            p:=ed.Fn(i,j,TypeData(t));
            IF p<WY1 THEN WY1:=p-(WY2-p)/10. END;
            IF p>WY2 THEN WY2:=p+(p-WY1)/10. END;
          END
        END;
      END;
(*
      IF (bd.TypeSystem=1) OR (bd.TypeSystem=5) OR (bd.TypeSystem=6) THEN
        FOR j:=1 TO ed.nEth DO
          p :=PasNap(j,t,ed);(**)
          IF p<WY1 THEN WY1:=p-(WY2-p)/10. END;
          IF p>WY2 THEN WY2:=p+(p-WY1)/10. END;
        END;
      END;
*)
    UNTIL(t+th>TP);
    IF WY1>=WY2 THEN WY1:=-1.; WY2:=1. END;
    WYH:=StepY(WY1,WY2);
    WX1:=T0;
    IF TP-T0<16. THEN WX2:=T0+16. ELSE WX2:=TP END;
    WXH:=StepX(WX1,WX2);
  END AllGraph;

  PROCEDURE View;
    VAR c: CHAR; a: CARDINAL;
        s,si: ARRAY [1..30] OF CHAR;
        g,okey: BOOLEAN;
        ok,i,pm: SHORTCARD;
        wt: TypeData;
  BEGIN
    SkyGraph;
    s:='䨪 樨 ';
    si:='ଠ  祭';
    wi.Define(XI1,XI2,YI1,YI2,bd,okey);
    wi.Open(si);
    g:=TRUE;
(*    WHelp(' ࠢ');*)
    AllGraph;
    WGraph(s,g,TRUE);
    BotStr('< ࠢ>  ६饭, <Tab>- 祭, <Esc>-室.');
    REPEAT
      c:=RdKey();
      IF c=CHR(0) THEN
        c:=RdKey();
        CASE c OF
        | CHR(60):  (* F2 *)
          ww.Open(XW1,XW2,YW1,YW2,' 祭:',TRUE);
          c:=RdKey();
          ww.Close;
        | CHR(81):  (* Page Down *)
          wt:=(WY2-WY1)*0.5;
          WY1:=WY1-wt; WY2:=WY2+wt;
          WYH:=StepY(WY1,WY2);
          WGraph(s,g,TRUE);
        | CHR(73):  (* Page Up *)
          wt:=(WY2-WY1)*0.25;
          WY1:=WY1+wt; WY2:=WY2-wt;
          WYH:=StepY(WY1,WY2);
          WGraph(s,g,TRUE);
        | CHR(83):  (* Del *)
          (*IF WXH<=50. THEN*)
            wt:=WX2-WX1;
            WX2:=WX2+wt;
            WXH:=StepX(WX1,WX2);
            WGraph(s,g,TRUE);
          (*END*)
        | CHR(82):  (* Insert *)
          IF WXH>=2. THEN
            wt:=(WX2-WX1)*0.5;
            WX2:=WX2-wt;
            WXH:=StepX(WX1,WX2);
            WGraph(s,g,TRUE);
          END
        | CHR(72):  (* Up *)
          WY1:=WY1+WYH; WY2:=WY2+WYH; WGraph(s,g,TRUE);
        | CHR(80):  (* Down *)
          WY1:=WY1-WYH; WY2:=WY2-WYH; WGraph(s,g,TRUE);
        | CHR(75):  (* Left *)
          WX1:=WX1-WXH; WX2:=WX2-WXH; WGraph(s,g,TRUE);
        | CHR(77):  (* Right *)
          WX1:=WX1+WXH; WX2:=WX2+WXH; WGraph(s,g,TRUE);
        | CHR(71):  (* Home *)
          wt:=WX2-WX1; WX1:=T0; WX2:=WX1+wt; WGraph(s,g,TRUE);
        | CHR(79):  (* End *)
          wt:=WX2-WX1; WX1:=T1-wt; WX2:=T1;  WGraph(s,g,TRUE);
        END;
      ELSIF c=CHR(9) THEN  (* Tab *)
        w.SetTitle(s,FALSE);
        wi.SetTitle(si,TRUE);
        BotStr('<1-9>- ⥬, <Enter>-ᮢ, <Space>-  , <Tab>- 䨪, <Esc>-室.');
        REPEAT
          wi.Edit(c);
          IF c=' ' THEN AllGraph END;
          IF c#CHR(27) THEN WGraph(s,g,FALSE) END;
        UNTIL((c=CHR(9)) OR (c=CHR(27)));
        BotStr('< ࠢ>  ६饭, <Tab>- 祭, <Esc>-室.');
        wi.SetTitle(si,FALSE);
        w.SetTitle(s,TRUE);
      ELSIF c=' ' THEN AllGraph; WGraph(s,g,TRUE)
      END;
    UNTIL(c=CHR(27));
    c:=' ';
    w.Close;
  END View;

  PROCEDURE Dispose;
    VAR s: CARDINAL;
  BEGIN
    s:=SIZE(TypeData)*CARDINAL(nEth*nVP);
    IF x#NIL THEN DEALLOCATE(x,s) END;
    s:=SIZE(TypeData)*CARDINAL(nEth*nVP);
    IF x1#NIL THEN DEALLOCATE(x1,s) END;
    s:=CARDINAL(nFn)*SIZE(Func);
    IF of#NIL THEN DEALLOCATE(of,s) END;
    ed.Dispose;
    IF adm_el THEN
      ar.Dispose;
    ELSE
      el.Dispose;
    END;
  END Dispose;

  BEGIN
    Init;
  END Solving;

BEGIN
END SolveDat.
